--
-- SecBus ( http://secbus.telecom-paristech.fr/ ) - This file is part of SecBus
-- Copyright (C) 2009-2015 - Telecom ParisTech
-- Contacts: contact-secbus@telecom-paristech.fr
--
-- This file must be used under the terms of the CeCILL.
-- This source file is licensed as described in the file COPYING, which
-- you should have received as part of this distribution. The terms
-- are also available at
-- http://www.cecill.info/licences/Licence_CeCILL_V2.1-en.txt
--

-- @brief Simulation environment for des_pkg package (regression test to run after each modification of des_pkg)
-- @author Renaud Pacalet (renaud.pacalet@telecom-paristech.fr)
-- @date 2014-02-28
--
-- Regression test of the des_pkg package against reference test patterns of DES standard companion document "DES modes of operation". Run after each package
-- change.
--
-- Behaviour:
-- Call the des_pkg.check_des_pkg procedure.
--
-- Primary inputs: none
--
-- Primary outputs: none

use work.des_pkg.all;

entity des_pkg_sim is
end entity des_pkg_sim;

architecture sim of des_pkg_sim is
begin
  process
  begin
    check_des_pkg;
    wait;
  end process;
end architecture sim;
